@echo off
set DEVICENM=4
set PRNT1NAME=STATIONFPRINTER
set PRNT2NAME=
set PRNT3NAME=
set PRNT4NAME=
echo Don't close this window, will close automatically.
echo Unconfiguring print driver(s)...

rem ----------------------------------------------------------------------------
rem This batch file will be excuted under Local System account by install.exe
rem in case of no --hideprompt option. In case of --hideprompt option, this will
rem be excuted by msiexec through wscript.exe.
rem ----------------------------------------------------------------------------

setlocal enabledelayedexpansion
set LOGFILE="%SystemRoot%\uninstall_printer.log"
set SCRIPT_DIR=%~DP0

call :LOG_INFO "%~0 was started."
call :LOG_INFO "List of available environment variables:"
set >> %LOGFILE%

call :LOG_INFO "Installed printer list before uninstall_printer.bat"
wmic printer LIST INSTANCE <NUL >> %LOGFILE% 2>&1
call :LOG_INFO "ERRORLEVEL=%ERRORLEVEL% - 0 means successfully listed"

SET K=0

:PRNT0
SET /A K=%K%+1
echo. >> %LOGFILE%

if "" neq "!PRNT%K%NAME!" (
  call :LOG_INFO "Deleting printer of !PRNT%K%NAME!..."
  call RUNDLL32 PRINTUI.DLL,PrintUIEntry /dl /n "!PRNT%K%NAME!" /q
  wmic PATH Win32_Printer WHERE ^(NAME="!PRNT%K%NAME!"^) Get Name <NUL 2>NUL |findstr /C:"!PRNT%K%NAME!" >NUL 2>&1
  call :LOG_INFO "ERRORLEVEL=!ERRORLEVEL! - 1 means successfully deleted"
)

if "%K%" neq "%DEVICENM%" (
	GOTO PRNT0
) else (
	GOTO PRNT5
)

:PRNT5

call :LOG_INFO "Installed printer list after uninstall_printer.bat:"
wmic printer LIST INSTANCE <NUL >> %LOGFILE% 2>&1
call :LOG_INFO "ERRORLEVEL=%ERRORLEVEL% - 0 means successfully listed"

call :LOG_INFO "Sleeping for 10 seconds"
ping 127.0.0.1 -n 10 >NUL 2>&1
call :LOG_INFO "Continue"

exit /b 0 

:LOG_DEBUG
	set X=
	for /f "skip=1 delims=" %%x in ('wmic os get localdatetime ^<NUL') do if not defined X set X=%%x
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^| DEBUG ^| %~nx0 ^| %~1
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^| DEBUG ^| %~nx0 ^| %~1>> %LOGFILE%
exit /b 0

:LOG_INFO
	set X=
	for /f "skip=1 delims=" %%x in ('wmic os get localdatetime ^<NUL') do if not defined X set X=%%x
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^|  INFO ^| %~nx0 ^| %~1
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^|  INFO ^| %~nx0 ^| %~1>> %LOGFILE%
exit /b 0

:LOG_WARN
	set X=
	for /f "skip=1 delims=" %%x in ('wmic os get localdatetime ^<NUL') do if not defined X set X=%%x
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^|  WARN ^| %~nx0 ^| %~1
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^|  WARN ^| %~nx0 ^| %~1>> %LOGFILE%
exit /b 0

:LOG_ERROR
	set X=
	for /f "skip=1 delims=" %%x in ('wmic os get localdatetime ^<NUL') do if not defined X set X=%%x
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^| ERROR ^| %~nx0 ^| %~1
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^| ERROR ^| %~nx0 ^| %~1>> %LOGFILE%
exit /b 0

:LOG_FATAL
	set X=
	for /f "skip=1 delims=" %%x in ('wmic os get localdatetime ^<NUL') do if not defined X set X=%%x
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^| FATAL ^| %~nx0 ^| %~1
	echo %X:~0,4%-%X:~4,2%-%X:~6,2% %X:~8,2%:%X:~10,2%:%X:~12,2%:%X:~15,3% ^| FATAL ^| %~nx0 ^| %~1>> %LOGFILE%
exit /b 0

endlocal

